
;--------------------------------------------------;
; File exetest.asm                                 ;
; Verifica a run-time di un programma EXE          ; 
;--------------------------------------------------;

;########### direttive per l'assembler ############

.386                                ; set di istruzioni a 32 bit
INCLUDE     EXELIB.INC              ; libreria di I/O

;######### dichiarazione tipi e costanti ##########

STACK_SIZE = 0400h                  ; 1024 byte per lo stack

;################ segmento dati ###################

DATASEGM    SEGMENT  PARA PUBLIC USE16 'DATA'

;---------- inizio definizione variabili ----------

strTitle    db    'PROGRAMMA DI PROVA EXETEST.ASM '
            db    'PER LA LIBRERIA EXELIB', 0
strExit     db    'Premere un tasto per terminare', 0

;----------- fine definizione variabili -----------

DATASEGM    ENDS

;############### segmento codice ##################

CODESEGM    SEGMENT  PARA PUBLIC USE16 'CODE'

   assume   cs: CODESEGM            ; assegna CODESEGM a CS
   
start:                              ; entry point

   mov      ax, DATASEGM            ; trasferisce DATASEGM
   mov      ds, ax                  ; in DS attraverso AX
   assume   ds: DATASEGM            ; assegna DATASEGM a DS

;------- inizio blocco principale istruzioni ------

   call     set80x50
   call     hideCursor
   call     clearScreen

   mov      dx, 000eh
   mov      bx, offset strTitle
   call     writeString

   call     clearRegisters
   call     showCPU

   call     readUdec8
   mov      dx, 0300h
   call     writeUdec8
   call     showCPU

   call     readUdec16
   mov      dx, 0400h
   call     writeUdec16
   call     showCPU

   call     readUdec32
   mov      dx, 0500h
   call     writeUdec32
   call     showCPU
   
   call     clearRegisters

   call     readSdec8
   mov      dx, 0700h
   call     writeSdec8
   call     showCPU
   
   call     readSdec16
   mov      dx, 0800h
   call     writeSdec16
   call     showCPU

   call     readSdec32
   mov      dx, 0900h
   call     writeSdec32
   call     showCPU

   call     clearRegisters

   call     readHex8
   mov      dx, 0b00h
   call     writeHex8
   call     showCPU

   call     readHex16
   mov      dx, 0c00h
   call     writeHex16
   call     showCPU

   call     readHex32
   mov      dx, 0d00h
   call     writeHex32
   call     showCPU

   call     clearRegisters

   call     readBin8
   mov      dx, 0f00h
   call     writeBin8
   call     showCPU

   call     readBin16
   mov      dx, 1000h
   call     writeBin16
   call     showCPU

   call     readBin32
   mov      dx, 1100h
   call     writeBin32
   call     showCPU  

   mov      dx, 1400h 
   mov      bx, offset strExit
   call     writeString

   call     waitChar
   call     clearScreen
   call     showCursor

;-------- fine blocco principale istruzioni -------
   
   mov      al, 00h                 ; codice di uscita
   mov      ah, 4ch                 ; proc. return to DOS
   int      21h                     ; chiama i servizi DOS
   
;------------- inizio blocco procedure ------------

;-------------- fine blocco procedure -------------
   
CODESEGM    ENDS

;################# segmento stack #################

STACKSEGM   SEGMENT  PARA STACK USE16 'STACK'

            db       STACK_SIZE dup (?)
            
STACKSEGM   ENDS

;##################################################

   END      start

